#include "../Framework2/OpenGL/OpenGLApp.h"
#include "../Framework2/Util/OpenGLModel.h"
#include "../Framework2/Util/CollisionSet.h"

#include "../Framework2/Util/TexturePacker.h"

#define VIEW_COUNT 8

#define SAMPLE_COUNT 100

#define LIGHT_COUNT 2

struct Vertex {
	vec3 pos;
	vec2 texCoord;
	vec2 texCoord2;
};

class MainApp : public OpenGLApp {
public:
	void processMovement(const vec3 &newPosition);
	void resetCamera();

	bool init();
	bool exit();

	bool load();
	bool unload();

	void drawLights();
	void drawScene(const int view);
	bool drawFrame();
protected:
	CollisionSet coll;

	vec3 lightPos[LIGHT_COUNT];
	float lightSize[LIGHT_COUNT];

	vec3 focusPoint;
	float radius;
	float blur;

	ShaderID lighting[VIEW_COUNT], combine;
	OpenGLModel *model;

	TextureID base[3], lightMap, rt[VIEW_COUNT];
	TextureID light;
};
